/*
 *  $Id: Loader.h 366 2009-09-11 14:33:45Z oicawa $
 *
 *  ===============================================================================
 *
 *   Copyright (C) 2008-2009  Masamitsu Oikawa  <oicawa@gmail.com>
 *   
 *   Permission is hereby granted, free of charge, to any person obtaining a copy
 *   of this software and associated documentation files (the "Software"), to deal
 *   in the Software without restriction, including without limitation the rights
 *   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *   copies of the Software, and to permit persons to whom the Software is
 *   furnished to do so, subject to the following conditions:
 *   
 *   The above copyright notice and this permission notice shall be included in
 *   all copies or substantial portions of the Software.
 *   
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
 *   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 *   THE SOFTWARE.
 *
 *  ===============================================================================
 */

 
#ifndef PUBLIC_LOADER_H_INCLUDED
#define PUBLIC_LOADER_H_INCLUDED


#include "Cria.h"
#include "Definition.h"
#include "Parser.h"
#include "List.h"



#define MAX_PATH_LENGTH 1024

struct LoaderTag
{
    String package_name;
    String library_name;
    void* library;
};



Loader
Loader_new(
	List path
);



Loader
Loader_parse(
    Parser parser
);



String
Loader_get_package_name(
    Loader loader
);



void
Loader_load(
    Loader loader,
    Interpreter interpreter
);



void
Loader_add_function(
    Interpreter interpreter,
    String functionName,
    CriaNativeFunction* functionPoint
);



void
Loader_unload(
	Loader loader
);



#endif
